//----------------------------------------------------------------------------
// pacman-like game
// copyright 2010 christopher rasmussen
// university of delaware
// v. 1.0

//----------------------------------------------------------------------------

#include "TeamNoHonorsRequired.hh"
const int runnerWeight = 20;

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

// ALL STUDENTS WRITE THIS FOR PROJECT 3

// ad-hoc or minimax ok for "The Arena"

void TeamNoHonorsRequired::update(const GameState & GS, BlockMaze *M)
{
   bool odd_team;
   if(name.find("odd")!=string::npos){
      odd_team = true;
   }
   else{
      odd_team = false;
   }
   BFS(position, M);
   
   //int currIndex;
   vector <int> team;
   
   int num_our_pills;
   int num_enemy_pills;
   int pill_i;// = find_closest_pill(GS, M, odd_team);
   int enemy_i = find_closest_enemy(GS, M, odd_team);

   for(int i = 0; i<GS.object_name.size(); i++){
      if(GS.object_name[i].find("runner")!=string::npos){
	 if(odd_team){
	    if(GS.object_name[i].find("odd")!=string::npos){
	       team.push_back(i);
	    }
	 }
	 else{
	    if(GS.object_name[i].find("even")!=string::npos){
	       team.push_back(i);
	    }
	 }
      }
   }
   
   //team strategy & movement::
   for(int i = 0; i<team.size(); i++){
      //for first player on team, or if only player::OFFENSE
      if(name==GS.object_name[team[i]]&&(i==0)){
	 if(odd_team){
	    if(M->is_even_side(position)) {
	       Dijkstra(position, GS, M, odd_team);
	       pill_i = find_closest_pill(GS, M, odd_team);
	       compute_BFS_path(GS.object_position[pill_i], path, M);
	       attempt_move(path[1].row, path[1].col, M);
	    }
	    else{//on own side
	       BFS(position, M);//to ignore the enemy on your side
	       pill_i = find_closest_pill(GS, M, odd_team);
	       compute_BFS_path(GS.object_position[pill_i], path, M);
	       attempt_move(path[1].row, path[1].col, M);
	    }
	 }
	 
	 else{//for even team
	    if(M->is_odd_side(position)) {
	       Dijkstra(position, GS, M, odd_team);
	       pill_i = find_closest_pill(GS, M, odd_team);
	       compute_BFS_path(GS.object_position[pill_i], path, M);
	       attempt_move(path[1].row, path[1].col, M);
	    }
	    else{//on own side
	       BFS(position, M);//to ignore the enemy on your side
	       pill_i = find_closest_pill(GS, M, odd_team);
	       compute_BFS_path(GS.object_position[pill_i], path, M);
	       attempt_move(path[1].row, path[1].col, M);
	    }
	 }
	 
      }
      
      //for second player on team::DEFENSE
      if(name==GS.object_name[team[i]]&&(i==1)){
	 if(odd_team){
	    if(M->is_odd_side(GS.object_position[enemy_i])) {
	       compute_BFS_path(GS.object_position[enemy_i], path, M);
	    }
	    else{
	       BFS(GS.object_position[enemy_i], M);
	       pill_i = find_closest_pill(GS, M, !odd_team);
	       BFS(position, M);
	       compute_BFS_path(GS.object_position[pill_i], path, M);
	    }
	    if(path.size()<3&&!(M->is_odd_side(GS.object_position[enemy_i]))){
	       attempt_move(last_position.row, last_position.col, M);
	    }
	    else{
	       attempt_move(path[1].row, path[1].col, M);
	    }
	 }
	 
	 else{//even team
	    if(M->is_even_side(GS.object_position[enemy_i])) {
	       compute_BFS_path(GS.object_position[enemy_i], path, M);
	    }
	    else{
	       BFS(GS.object_position[enemy_i], M);
	       pill_i = find_closest_pill(GS, M, !odd_team);
	       BFS(position, M);
	       compute_BFS_path(GS.object_position[pill_i], path, M);
	    }
	    if(path.size()<3&&!(M->is_even_side(GS.object_position[enemy_i]))){
	       attempt_move(last_position.row, last_position.col, M);
	    }
	    else{
	       attempt_move(path[1].row, path[1].col, M);
	    }
	 }
      }
      
      //for third player on team if they exist
      if(name==GS.object_name[team[i]]&&(i==2)){
	 if(odd_team){
	    if(M->is_even_side(position)) {
	       Dijkstra(position, GS, M, odd_team);
	       pill_i = find_closest_pill(GS, M, odd_team);
	       compute_BFS_path(GS.object_position[pill_i], path, M);
	       attempt_move(path[1].row, path[1].col, M);
	    }
	    else{//on own side
	       BFS(position, M);//to ignore the enemy on your side
	       pill_i = find_closest_pill(GS, M, odd_team);
	       compute_BFS_path(GS.object_position[pill_i], path, M);
	       attempt_move(path[1].row, path[1].col, M);
	    }
	 }
	 
	 else{//for even team
	    if(M->is_odd_side(position)) {
	       Dijkstra(position, GS, M, odd_team);
	       pill_i = find_closest_pill(GS, M, odd_team);
	       compute_BFS_path(GS.object_position[pill_i], path, M);
	       attempt_move(path[1].row, path[1].col, M);
	    }
	    else{//on own side
	       BFS(position, M);//to ignore the enemy on your side
	       pill_i = find_closest_pill(GS, M, odd_team);
	       compute_BFS_path(GS.object_position[pill_i], path, M);
	       attempt_move(path[1].row, path[1].col, M);
	    }
	 }
	 
      }
   }
   
   
   //attempt_move(path[1].row, path[1].col, M);

}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

int find_closest_pill(const GameState & GS, BlockMaze *M, bool odd_team){
   int shortest_path;
   bool flag = false;
   int shortest_distance;
   int currDist;
   
   for(int i = 0; i<GS.object_position.size()&&flag==false; i++)
   {
      if(GS.object_name[i].find("power pill")!=string::npos){
	 if(odd_team){
	    if(M->is_even_side(GS.object_position[i])) {//M->is_even_side(GS.object_position[i])
	       shortest_path = i;
	       shortest_distance = (M->vertex[GS.object_position[i].row][GS.object_position[i].col]).distance;
	       flag=true;
	    }
	 }
	 
	 else{
	    if(M->is_odd_side(GS.object_position[i])) {//M->is_even_side(GS.object_position[i])
	       shortest_path = i;
	       shortest_distance = (M->vertex[GS.object_position[i].row][GS.object_position[i].col]).distance;
	       flag=true;
	    }
	 }
	 
      }
   }
 
   
   //finds the nearest power pill, rather than just the "next" one.
   for(int i = 0; i<GS.object_position.size(); i++)
   {
      if(GS.object_name[i].find("power pill")!=string::npos){
	 if(odd_team){
	    if(M->is_even_side(GS.object_position[i])) {//M->is_even_side(GS.object_position[i])
   		currDist = (M->vertex[GS.object_position[i].row][GS.object_position[i].col]).distance;
   		//shortest_distance = (M->vertex[GS.object_position[shortest_path].row][GS.object_position[shortest_path].col]).distance;
    		
    		if(currDist < shortest_distance ){
    			shortest_path = i;
			shortest_distance = (M->vertex[GS.object_position[i].row][GS.object_position[i].col]).distance;
    		}
	    }
	 }
	 
	 else{
	    if(M->is_odd_side(GS.object_position[i])) {//M->is_even_side(GS.object_position[i])
   		currDist = (M->vertex[GS.object_position[i].row][GS.object_position[i].col]).distance;
   		//shortest_distance = (M->vertex[GS.object_position[shortest_path].row][GS.object_position[shortest_path].col]).distance;
    		
    		if(currDist < shortest_distance ){
    			shortest_path = i;
			shortest_distance = (M->vertex[GS.object_position[i].row][GS.object_position[i].col]).distance;
    		}
	    }
	 }	 
	 	 
      }
    }
    
    return shortest_path;
    
}

//------------------------------------------------------------------------------


//-----------------------------------------------------------------------------

int find_closest_enemy(const GameState & GS, BlockMaze *M, bool odd_team){
   int closestRunner;
   int shortest_distance;
   int currDist;
   int i;
   bool flag = false;   
   
   for(i = 0; i < GS.object_name.size()&&flag==false; i ++){
      if(GS.object_name[i].find("runner") != string::npos){
	 if(odd_team){
	    if(is_even_team(GS.object_name[i])){
	       closestRunner = i;
	       shortest_distance = (M->vertex[GS.object_position[i].row][GS.object_position[i].col]).distance;
	       break;
	    }
	 }
	 else{//for the even team
	    if(is_odd_team(GS.object_name[i])){
	       closestRunner = i;
	       shortest_distance = (M->vertex[GS.object_position[i].row][GS.object_position[i].col]).distance;
	       break;
	    }
	 }
      }
   }
     
   for(i; i<GS.object_position.size(); i++){
      
      if(GS.object_name[i].find("runner") != string::npos){
	
	 if(odd_team){
	    if(is_even_team(GS.object_name[i])){
	       currDist = (M->vertex[GS.object_position[i].row][GS.object_position[i].col]).distance;
	       if(currDist < shortest_distance ){
		  closestRunner = i;
		  shortest_distance = (M->vertex[GS.object_position[i].row][GS.object_position[i].col]).distance;
	       }
	    }	 
	 }
	 
	 else{//is even team
	    if(is_odd_team(GS.object_name[i])){
	       currDist = (M->vertex[GS.object_position[i].row][GS.object_position[i].col]).distance;
	       if(currDist < shortest_distance ){
		  closestRunner = i;
		  shortest_distance = (M->vertex[GS.object_position[i].row][GS.object_position[i].col]).distance;
	       }
	    }	 
	 }
      }
      
   }
   return closestRunner;  
}

//-------------------------------------------------------------------------

void Dijkstra(Point_2D start, const GameState &GS, BlockMaze *M, bool odd_team){
  
  for(int r = 0; r < M->num_rows; r++)
    {
      for(int c = 0; c < M->num_cols; c++)
	{
	  M->vertex[r][c].distance = DIST_INFINITY;
	  M->vertex[r][c].known = false;
	}
    }
  
  M->vertex[start.row][start.col].distance = 0;
  
  for(int currDist = 0; currDist < (M->num_rows*M->num_cols); currDist++)
  {
    for(int r = 0; r < M->num_rows; r++)
    {
      for(int c = 0; c < M->num_cols; c++)
      {
	if(M->vertex[r][c].is_wall()){}
	else if(!M->vertex[r][c].known && M->vertex[r][c].distance == currDist)
      	{
	  M->vertex[r][c].known = true;
	  
	  int y, x;//y to mean change in row, x to mean change in col
	  for(int i = 0; i<4; i++)
	  {
	    if(i==0)//case north
	    {
	      y = -1;
	      x = 0;
	    }
	    else if(i==1)//case south
	    {
	      y = 1;
	      x = 0;
	    }
	    else if(i==2)//case east
	    {
	      y = 0;
	      x = 1;
	    }
	    else if(i==3)//case west
	    {
	      y = 0;
	      x = -1;
	    }
	    
	    if(M->vertex[r+y][c+x].distance == DIST_INFINITY)
	    {
	      M->vertex[r+y][c+x].distance = currDist + 1;
	      //if ghosts, add to distance
	      for(int i = 0; i<GS.object_name.size(); i++){
	       if(GS.object_position[i].row == M->vertex[r+y][c+x].pos.row && 
		  GS.object_position[i].col == M->vertex[r+y][c+x].pos.col){  
		     if(GS.object_name[i].find("runner")!=string::npos){
			if(odd_team){
			   if(is_even_team(GS.object_name[i])){
			      if(M->is_even_side(GS.object_position[i])) {
				 M->vertex[r+y][c+x].distance += runnerWeight;
			      }
			   }
			}	
		     
			else{
			   if(is_odd_team(GS.object_name[i])){
			      if(M->is_odd_side(GS.object_position[i])) {
       
				 M->vertex[r+y][c+x].distance += runnerWeight;
			      }
			   }
			}
		     }	
		  }
		}
	      
	      
	      M->vertex[r+y][c+x].path = &(M->vertex[r][c]);
	    } 
	  }  
	}
      }
    }
  }
  
  
}
//-----------------------------------------------------------------------
int num_pills_left(const GameState & GS, BlockMaze *M, bool odd_team){

   int num_pills = 0;
   
   for(int i = 0; i<GS.object_position.size(); i++)
   {
      if(GS.object_name[i].find("power pill")!=string::npos){
	 if(odd_team){
	    if(M->is_even_side(GS.object_position[i])) {
	       num_pills++;
	    }
	 }
	 
	 else{//even team pills
	    if(M->is_odd_side(GS.object_position[i])) {
	       num_pills++;
	    }
	 }
	 
      }
   }
   
   return num_pills;
}


 
