#ifndef TEAMTARDIS_HH
#define TEAMTARDIS_HH

//----------------------------------------------------------------------------
// pacman-like game
// copyright 2010 christopher rasmussen
// university of delaware
// v. 1.0
 
//----------------------------------------------------------------------------

#include "Agent.hh"

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

class TeamTardis : public Agent
{
public:

  TeamTardis(string s, char c, int i, int x = 0, int y = 0) : Agent(s, c, i, x, y) { }
  ~TeamTardis() { }

  void update(const GameState &, BlockMaze *);

};

class MoveNode{
public:
  MoveNode(){north = NULL; south = NULL; east = NULL; west = NULL;}
  MoveNode* north;
  MoveNode* south;
  MoveNode* east;
  MoveNode* west;

  string moves;

};

bool minimax_value(bool runner_turn, int depth, const GameState & GS, BlockMaze *M, float & best_value, Point_2D best_move);
float eval(const GameState & GS, BlockMaze *M);
bool terminal_state(float & utility, const GameState & GS, BlockMaze *M);
bool cutoff_test(int depth, const GameState & GS, BlockMaze *M);
void create_tree(int numGhosts, int curGhosts, MoveNode* & root);
void make_list(vector<string> & moves, MoveNode* T);
void eval_list(vector<string> & moves, vector<Point_2D> pos, BlockMaze* M);
void create_ghost_game_state(string move, GameState & GS, BlockMaze* M);
bool create_game_state(char dir, GameState & GS, BlockMaze* M, Point_2D & newPos, bool odd, int index);
void Dijkstra(Point_2D start, BlockMaze *M);
int cost(BlockVertex next);

class CompareBlocks {
public:
  bool operator()(BlockVertex & vb1, BlockVertex & vb2) {
    return vb1.distance > vb2.distance;
  }
};

//----------------------------------------------------------------------------

#endif
