//----------------------------------------------------------------------------
// pacman-like game
// copyright 2010 christopher rasmussen
// university of delaware
// v. 1.0

//----------------------------------------------------------------------------

#include "TeamWazzle.hh"

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

// ALL STUDENTS WRITE THIS FOR PROJECT 3

// ad-hoc or minimax ok for "The Arena"

void distPillCopy(BlockMaze* M, vector< vector <BlockVertex> > & dist, int factor)
{
  for (int i = 0; i < dist.size(); i++)
    for (int j = 0; j < dist[i].size(); j++)
      dist[i][j].distance += (M->vertex[i][j].distance)*factor;
}

//----------------------------------------------------------------------------
//DISTANCE COPY FOR GHOSTS
void distGhostCopy(BlockMaze* M, vector< vector <BlockVertex> > & dist, float factor)
{
  for (int i = 0; i < dist.size(); i++)
    for (int j = 0; j < dist[i].size(); j++)
      {
	//int a = (factor/((M->vertex[i][j].distance)+1));
	if (M->vertex[i][j].distance != -1)
	  dist[i][j].distance = (factor/(M->vertex[i][j].distance));
      }
}
//----------------------------------------------------------------------------
//DESC: A function that evaluates all sizes and picks the lowest value on the sink map.  If values are equal, it checks the square after that
Point_2D calcNextStep(Point_2D v, BlockMaze* M, int a=1)
{
  if (v.col-a>0 && !M->vertex[v.row][v.col-a].is_wall() && M->vertex[v.row][v.col-a].distance < M->vertex[v.row][v.col].distance)
    return M->vertex[v.row][v.col-1].pos;
      
  else if (v.col+a<M->num_cols-1 && !M->vertex[v.row][v.col+a].is_wall() && M->vertex[v.row][v.col+a].distance < M->vertex[v.row][v.col].distance)
    return M->vertex[v.row][v.col+1].pos;
      
  else if (v.row+a<M->num_rows-1 && !M->vertex[v.row+a][v.col].is_wall() && M->vertex[v.row+a][v.col].distance < M->vertex[v.row][v.col].distance)
    return M->vertex[v.row+1][v.col].pos;
      
  else if (v.row-a>0 && (!M->vertex[v.row-a][v.col].is_wall()) && M->vertex[v.row-a][v.col].distance < M->vertex[v.row][v.col].distance)
    return M->vertex[v.row-1][v.col].pos;
  else if (a < 5)
    return calcNextStep(v, M, a+1);    
}


//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
bool inPath(vector<Point_2D> path, vector<Point_2D> ghosts)
{
  for (int i = 0; i < ghosts.size(); i++)
    for (int j = 0; j < path.size(); j++)
      if (ghosts[i].y == path[j].y && ghosts[i].x == path[j].x)
	return true;
 
  return false;
}

void TeamWazzle::update(const GameState & GS, BlockMaze *M)
{
  // uncomment for total manual control
  //  return;
  BFS(position, M);

  int place = 0;
  int place2 = 0;
  vector<Point_2D> pp, even, odd;
  
  vector < vector <BlockVertex> > dist = M->vertex;
 
  //INITIALIZE DISTANCES AS 0;
  for (int i = 0; i < M->vertex.size(); i++)
    for (int j = 0; j < M->vertex[i].size(); j++)
      {
	dist[i][j].distance = 0;
	//M->vertex[i][j].distance = 0;
      }

  //MAKE VECTOR FOR GHOSTS AND POWER PILLS
  for (int i = 0; i < GS.object_name.size(); i++)
    {
      if (!GS.object_name[i].compare("power pill") && ((is_odd_team(name) && GS.object_position[i].x > M->num_cols/2) || (is_even_team(name) && GS.object_position[i].x < M->num_cols/2)))
	pp.push_back(GS.object_position[i]);

      else if (!GS.object_name[i].compare(GS.object_name[i].size()-2, GS.object_name[i].size()-1, "n"))
	even.push_back(GS.object_position[i]);
      
      else if (!GS.object_name[i].compare(GS.object_name[i].size()-2, GS.object_name[i].size()-1, "d"))
	odd.push_back(GS.object_position[i]);
    }
  if (pp.empty())
    return;
  //FIND LOWEST DISTANCE AND NEAREST POWER PILL
  for (int i = 0;i < pp.size(); i++)
  {
    if (M->vertex[pp[i].y][pp[i].x].distance <= M->vertex[pp[place].y][pp[place].x].distance)
      place = i;
      }
  //place = rand() % pp.size();

  //FIND CLOSEST GHOST
  if (is_odd_team(name))
    {
      for (int i = 0;i < even.size(); i++)
	{
	  if (M->vertex[even[i].y][even[i].x].distance <= M->vertex[even[place2].y][even[place2].x].distance)
	    place2 = i;
	}  
    }
  else
    {
      for (int i = 0;i < odd.size(); i++)
	{
	  if (M->vertex[odd[i].y][odd[i].x].distance <= M->vertex[odd[place2].y][odd[place2].x].distance)
	    place2 = i;
	}  
    }

  int value = rand() % 10;


  BFS(position, M);

  //if (is_odd_team(name))
    {
      if (value != 0 || M->vertex[pp[place].y][pp[place].x].distance < 5)
	{
	  BFS(pp[place], M);
	  //compute_BFS_path(position, path, M);
	}
      else
	{
	  if (place + 1 < pp.size() - 1)
	    BFS(pp[place+1], M);
	  else if (place - 1 > 0)
	    BFS(pp[place -1], M);
	  else
	    BFS(pp[place], M);
		
	}
    }
    //else
  {

	{
	  //BFS(pp[place], M);
	}
    }

  //PICK DIRECTION TO MOVE IN
  //Point_2D next = calcSum(position, M);
  Point_2D next = calcNextStep(position, M);
  
  //MOVE TO NEXT SQUARE ON PATH
  attempt_move(next.y, next.x, M);
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

