//----------------------------------------------------------------------------
// some convenience functions, types, and constants for mazerunner
// copyright 2010 christopher rasmussen
// v. 1.03
// * took out old commented code
// * changed wall color to white, added cyan and purple
// * added rand_in_range()
// * added coin_flip()

//----------------------------------------------------------------------------

#include "Utils.hh"

//----------------------------------------------------------------------------

// get ready to draw with ncurses library

void init_ncurses()
{
  initscr();

  // comment this out to default to no colors

  if (has_colors()) {

    start_color();

    init_pair(WALL_COLOR, COLOR_BLACK, COLOR_WHITE);     // white background

    init_pair(YELLOW_COLOR, COLOR_YELLOW, COLOR_BLACK);
    init_pair(WHITE_COLOR, COLOR_WHITE, COLOR_BLACK);
    init_pair(BLUE_COLOR, COLOR_BLUE, COLOR_BLACK);
    init_pair(GREEN_COLOR, COLOR_GREEN, COLOR_BLACK);
    init_pair(RED_COLOR, COLOR_RED, COLOR_BLACK);
    init_pair(CYAN_COLOR, COLOR_CYAN, COLOR_BLACK);
    init_pair(PURPLE_COLOR, COLOR_MAGENTA, COLOR_BLACK);
  }

  raw();
  noecho();
  curs_set(0);   // make cursor invisible
}

//----------------------------------------------------------------------------

// get out of ncurses mode so terminal is not screwed up when program exits

void terminate_ncurses()
{
  endwin();
}

//----------------------------------------------------------------------------

// return a random int in [lower, upper]

// assuming upper >= lower

int rand_in_range(int lower, int upper)
{
  return (lower + rand() % (1 + upper - lower));
}

//----------------------------------------------------------------------------

// true 50% of time

bool coin_flip()
{
  return (rand_in_range(0, 1) == 1);
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
