#ifndef UTILS_HH
#define UTILS_HH

//----------------------------------------------------------------------------
// some convenience functions, types, and constants for mazerunner
// copyright 2010 christopher rasmussen
// v. 1.04
// * took out old commented code
// * added rand_in_range()
// * overloaded == operator for Point_2D
// * added coin_flip()

//----------------------------------------------------------------------------

#include <iostream>
#include <cstdlib>
#include <time.h>
#include <ncurses.h>
#include <queue>
#include <string>
#include <sstream>
#include <map>
#include <cmath>
#include <string.h>

using namespace std;

//----------------------------------------------------------------------------

struct Point_2D
{
  Point_2D() { row = col = 0; }
  Point_2D(int r, int c) { row = r; col = c; }
  bool operator==(const Point_2D & other) const { return col == other.col && row == other.row; }

  union {
    int x;
    int col;
  };
  union {
    int y;
    int row;
  };
};

//----------------------------------------------------------------------------


void init_ncurses();
void terminate_ncurses();
int rand_in_range(int, int);
bool coin_flip();

// these are referring to agents--the wall color is "special"

#define FIRST_COLOR      2
#define NUM_COLORS       7

#define WALL_COLOR       1
#define YELLOW_COLOR     2
#define RED_COLOR        3
#define GREEN_COLOR      4
#define BLUE_COLOR       5
#define WHITE_COLOR      6
#define CYAN_COLOR       7
#define PURPLE_COLOR     8

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#endif
